#include <string>
#include <iostream>
#include <numeric>
#include <limits>

#include <stdlib.h>
#include <stdio.h>

#include <cuda.h>

#include "util.h"

using namespace std;

void error(string str, int code)
{
    cerr << str << endl;
    exit(code);
}


// n floats are generated in out in range [lower_limit,upper_limit]
// must seed rand in main
vector<float> generate_random_vector(int n, float lower_limit, float upper_limit)
{
    vector<float> vec;
    float range = upper_limit - lower_limit;
    for(int i=0; i<n; i++)
        vec.push_back(((double)rand() * range) / RAND_MAX + lower_limit);
    return vec;
}

float vector_mean(std::vector<float> vec)
{
    float sum = accumulate(vec.begin(),vec.end(),0);
    return sum / vec.size();
}
float vector_abs_mean(std::vector<float> vec)
{
    float sum = 0;
    for(size_t i=0;i<vec.size();i++)
        sum += abs(vec[i]);
    return sum / vec.size();
}
float vector_stdev(std::vector<float> vec)
{
    float mean = vector_mean(vec);
    float dev = 0;
    for(size_t i=0;i<vec.size();i++)
    {
        float e = vec[i] - mean;
        dev += e*e;
    }
    return sqrt(dev/vec.size());
}
float vector_max(std::vector<float> vec)
{
    float max_f = - numeric_limits<float>::max();
    for(size_t i=0;i<vec.size();i++)
        max_f = max(max_f,vec[i]);
    return max_f;
}
